]> git.notmuchmail.org Git - notmuch/blobdiff - test/test-lib.sh
lib/cli: pass GMIME_ENABLE_RFC2047_WORKAROUNDS to g_mime_init()
[notmuch] / test / test-lib.sh
index 77063a4d304d83709826d073ed5486df0f02d212..d3a8c58e97b92eb5382341860fb0e493aa8209b2 100644 (file)
@@ -22,6 +22,9 @@ if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
     exit 1
 fi
 
+# Make sure echo builtin does not expand backslash-escape sequences by default.
+shopt -u xpg_echo
+
 # if --tee was passed, write the output not only to the terminal, but
 # additionally to the file test-results/$BASENAME.out, too.
 case "$GIT_TEST_TEE_STARTED, $* " in
@@ -41,6 +44,10 @@ esac
 # Keep the original TERM for say_color and test_emacs
 ORIGINAL_TERM=$TERM
 
+# dtach(1) provides more capable terminal environment to anything
+# that requires more than dumb terminal...
+[ x"${TERM:-dumb}" = xdumb ] && DTACH_TERM=vt100 || DTACH_TERM=$TERM
+
 # For repeatability, reset the environment to known value.
 LANG=C
 LC_ALL=C
@@ -190,22 +197,39 @@ test_fixed=0
 test_broken=0
 test_success=0
 
-die () {
+_die_common () {
        code=$?
+       trap - EXIT
+       set +ex
        rm -rf "$TEST_TMPDIR"
+}
+
+die () {
+       _die_common
        if test -n "$GIT_EXIT_OK"
        then
                exit $code
        else
-               echo >&5 "FATAL: Unexpected exit with code $code"
+               exec >&5
+               say_color error '%-6s' FATAL
+               echo " $test_subtest_name"
+               echo
+               echo "Unexpected exit while executing $0. Exit code $code."
                exit 1
        fi
 }
 
+die_signal () {
+       _die_common
+       echo >&5 "FATAL: $0: interrupted by signal" $((code - 128))
+       exit $code
+}
+
 GIT_EXIT_OK=
 # Note: TEST_TMPDIR *NOT* exported!
 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
 trap 'die' EXIT
+trap 'die_signal' HUP INT TERM
 
 test_decode_color () {
        sed     -e 's/.\[1m/<WHITE>/g' \
@@ -494,12 +518,12 @@ test_expect_equal ()
        if ! test_skip "$test_subtest_name"
        then
                if [ "$output" = "$expected" ]; then
-                       test_ok_ "$test_subtest_name"
+                       test_ok_
                else
                        testname=$this_test.$test_count
                        echo "$expected" > $testname.expected
                        echo "$output" > $testname.output
-                       test_failure_ "$test_subtest_name" "$(diff -u $testname.expected $testname.output)"
+                       test_failure_ "$(diff -u $testname.expected $testname.output)"
                fi
     fi
 }
@@ -520,12 +544,12 @@ test_expect_equal_file ()
        if ! test_skip "$test_subtest_name"
        then
                if diff -q "$file1" "$file2" >/dev/null ; then
-                       test_ok_ "$test_subtest_name"
+                       test_ok_
                else
                        testname=$this_test.$test_count
                        cp "$file1" "$testname.$basename1"
                        cp "$file2" "$testname.$basename2"
-                       test_failure_ "$test_subtest_name" "$(diff -u "$testname.$basename1" "$testname.$basename2")"
+                       test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
                fi
     fi
 }
@@ -534,8 +558,13 @@ test_expect_equal_file ()
 # canonicalized before diff'ing.  If an argument cannot be parsed, it
 # is used unchanged so that there's something to diff against.
 test_expect_equal_json () {
-    output=$(echo "$1" | python -mjson.tool || echo "$1")
-    expected=$(echo "$2" | python -mjson.tool || echo "$2")
+    # The test suite forces LC_ALL=C, but this causes Python 3 to
+    # decode stdin as ASCII.  We need to read JSON in UTF-8, so
+    # override Python's stdio encoding defaults.
+    output=$(echo "$1" | PYTHONIOENCODING=utf-8 python -mjson.tool \
+        || echo "$1")
+    expected=$(echo "$2" | PYTHONIOENCODING=utf-8 python -mjson.tool \
+        || echo "$2")
     shift 2
     test_expect_equal "$output" "$expected" "$@"
 }
@@ -558,9 +587,9 @@ test_emacs_expect_t () {
                result=$(cat OUTPUT)
                if [ "$result" = t ]
                then
-                       test_ok_ "$test_subtest_name"
+                       test_ok_
                else
-                       test_failure_ "$test_subtest_name" "${result}"
+                       test_failure_ "${result}"
                fi
        else
                # Restore state after the (non) test.
@@ -576,7 +605,7 @@ NOTMUCH_NEW ()
 
 notmuch_search_sanitize ()
 {
-    sed -r -e 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
+    perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
 }
 
 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
@@ -595,7 +624,7 @@ notmuch_json_show_sanitize ()
 {
     sed \
        -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
-       -e 's|"filename": "[^"]*",|"filename": "YYYYY",|g'
+       -e 's|"filename": "/[^"]*",|"filename": "YYYYY",|g'
 }
 
 # End of notmuch helper functions
@@ -625,18 +654,22 @@ test_have_prereq () {
        esac
 }
 
+declare -A test_missing_external_prereq_
+declare -A test_subtest_missing_external_prereq_
+
 # declare prerequisite for the given external binary
 test_declare_external_prereq () {
        binary="$1"
        test "$#" = 2 && name=$2 || name="$binary(1)"
 
-       hash $binary 2>/dev/null || eval "
-       test_missing_external_prereq_${binary}_=t
+       if ! hash $binary 2>/dev/null; then
+               test_missing_external_prereq_["${binary}"]=t
+               eval "
 $binary () {
-       echo -n \"\$test_subtest_missing_external_prereqs_ \" | grep -qe \" $name \" ||
-       test_subtest_missing_external_prereqs_=\"\$test_subtest_missing_external_prereqs_ $name\"
+       test_subtest_missing_external_prereq_[\"${name}\"]=t
        false
 }"
+       fi
 }
 
 # Explicitly require external prerequisite.  Useful when binary is
@@ -644,7 +677,7 @@ $binary () {
 # Returns success if dependency is available, failure otherwise.
 test_require_external_prereq () {
        binary="$1"
-       if [ "$(eval echo -n \$test_missing_external_prereq_${binary}_)" = t ]; then
+       if [[ ${test_missing_external_prereq_["${binary}"]} == t ]]; then
                # dependency is missing, call the replacement function to note it
                eval "$binary"
        else
@@ -657,12 +690,12 @@ test_require_external_prereq () {
 
 test_ok_ () {
        if test "$test_subtest_known_broken_" = "t"; then
-               test_known_broken_ok_ "$@"
+               test_known_broken_ok_
                return
        fi
        test_success=$(($test_success + 1))
        say_color pass "%-6s" "PASS"
-       echo " $@"
+       echo " $test_subtest_name"
 }
 
 test_failure_ () {
@@ -671,7 +704,7 @@ test_failure_ () {
                return
        fi
        test_failure=$(($test_failure + 1))
-       test_failure_message_ "FAIL" "$@"
+       test_failure_message_ "FAIL" "$test_subtest_name" "$@"
        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
        return 1
 }
@@ -688,13 +721,13 @@ test_known_broken_ok_ () {
        test_reset_state_
        test_fixed=$(($test_fixed+1))
        say_color pass "%-6s" "FIXED"
-       echo " $@"
+       echo " $test_subtest_name"
 }
 
 test_known_broken_failure_ () {
        test_reset_state_
        test_broken=$(($test_broken+1))
-       test_failure_message_ "BROKEN" "$@"
+       test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
        return 1
 }
 
@@ -737,9 +770,9 @@ test_skip () {
 }
 
 test_check_missing_external_prereqs_ () {
-       if test -n "$test_subtest_missing_external_prereqs_"; then
-               say_color skip >&1 "missing prerequisites:"
-               echo "$test_subtest_missing_external_prereqs_" >&1
+       if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
+               say_color skip >&1 "missing prerequisites: "
+               echo ${!test_subtest_missing_external_prereq_[@]} >&1
                test_report_skip_ "$@"
        else
                false
@@ -762,6 +795,7 @@ test_expect_success () {
        test "$#" = 3 && { prereq=$1; shift; } || prereq=
        test "$#" = 2 ||
        error "bug in the test script: not 2 or 3 parameters to test-expect-success"
+       test_subtest_name="$1"
        test_reset_state_
        if ! test_skip "$@"
        then
@@ -771,9 +805,9 @@ test_expect_success () {
                test_check_missing_external_prereqs_ "$@" ||
                if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
                then
-                       test_ok_ "$1"
+                       test_ok_
                else
-                       test_failure_ "$@"
+                       test_failure_ "$2"
                fi
        fi
 }
@@ -782,6 +816,7 @@ test_expect_code () {
        test "$#" = 4 && { prereq=$1; shift; } || prereq=
        test "$#" = 3 ||
        error "bug in the test script: not 3 or 4 parameters to test-expect-code"
+       test_subtest_name="$2"
        test_reset_state_
        if ! test_skip "$@"
        then
@@ -791,9 +826,9 @@ test_expect_code () {
                test_check_missing_external_prereqs_ "$@" ||
                if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
                then
-                       test_ok_ "$2"
+                       test_ok_
                else
-                       test_failure_ "$@"
+                       test_failure_ "exit code $eval_ret, expected $1" "$3"
                fi
        fi
 }
@@ -810,10 +845,10 @@ test_external () {
        test "$#" = 4 && { prereq=$1; shift; } || prereq=
        test "$#" = 3 ||
        error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
-       descr="$1"
+       test_subtest_name="$1"
        shift
        test_reset_state_
-       if ! test_skip "$descr" "$@"
+       if ! test_skip "$test_subtest_name" "$@"
        then
                # Announce the script to reduce confusion about the
                # test output that follows.
@@ -824,9 +859,9 @@ test_external () {
                "$@" 2>&4
                if [ "$?" = 0 ]
                then
-                       test_ok_ "$descr"
+                       test_ok_
                else
-                       test_failure_ "$descr" "$@"
+                       test_failure_ "$@"
                fi
        fi
 }
@@ -840,11 +875,11 @@ test_external_without_stderr () {
        stderr="$tmp/git-external-stderr.$$.tmp"
        test_external "$@" 4> "$stderr"
        [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
-       descr="no stderr: $1"
+       test_subtest_name="no stderr: $1"
        shift
        if [ ! -s "$stderr" ]; then
                rm "$stderr"
-               test_ok_ "$descr"
+               test_ok_
        else
                if [ "$verbose" = t ]; then
                        output=`echo; echo Stderr is:; cat "$stderr"`
@@ -853,7 +888,7 @@ test_external_without_stderr () {
                fi
                # rm first in case test_failure exits.
                rm "$stderr"
-               test_failure_ "$descr" "$@" "$output"
+               test_failure_ "$@" "$output"
        fi
 }
 
@@ -987,9 +1022,10 @@ test_emacs () {
                fi
                server_name="notmuch-test-suite-$$"
                # start a detached session with an emacs server
-               # user's TERM is given to dtach which assumes a minimally
+               # user's TERM (or 'vt100' in case user's TERM is unset, empty
+               # or 'dumb') is given to dtach which assumes a minimally
                # VT100-compatible terminal -- and emacs inherits that
-               TERM=$ORIGINAL_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
+               TERM=$DTACH_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
                        sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
                                --no-window-system \
                                $load_emacs_tests \
@@ -1022,7 +1058,7 @@ test_python() {
        # most others as /usr/bin/python. So first try python2, and fallback to
        # python if python2 doesn't exist.
        cmd=python2
-       [[ "$test_missing_external_prereq_python2_" = t ]] && cmd=python
+       [[ ${test_missing_external_prereq_[python2]} == t ]] && cmd=python
 
        (echo "import sys; _orig_stdout=sys.stdout; sys.stdout=open('OUTPUT', 'w')"; cat) \
                | $cmd -
@@ -1064,7 +1100,7 @@ test_reset_state_ () {
        test -z "$test_init_done_" && test_init_
 
        test_subtest_known_broken_=
-       test_subtest_missing_external_prereqs_=
+       test_subtest_missing_external_prereq_=()
 }
 
 # called once before the first subtest